Index: trunk/LMDZ.TITAN/libf/muphytitan/mm_globals.f90
===================================================================
--- trunk/LMDZ.TITAN/libf/muphytitan/mm_globals.f90	(revision 3082)
+++ trunk/LMDZ.TITAN/libf/muphytitan/mm_globals.f90	(revision 3083)
@@ -680,7 +734,7 @@
         RETURN
       ENDIF
-      ! Reads species properties configuration file  
+      ! Reads species properties configuration file
       err = cfg_read_config(cp,TRIM(spcfile)) ; IF (err /= 0) RETURN
-      err = cfg_get_value(cp,"used_species",species) 
+      err = cfg_get_value(cp,"used_species",species)
       IF (err /= 0) THEN
         err = error("mm_global_init: cannot retrieve 'used_species' values",-1)
@@ -691,5 +745,5 @@
       ALLOCATE(mm_spcname(mm_nesp),mm_xESPS(mm_nesp))
       DO i=1,mm_nesp
-        mm_spcname(i) = to_lower(species(i))
+        mm_spcname(i) = TRIM(species(i))
         IF(.NOT.cfg_has_section(cp,TRIM(mm_spcname(i)))) THEN
           err = error("mm_global_init: Cannot find "//TRIM(mm_spcname(i))//" properties",-1)
@@ -708,66 +762,107 @@
 
     ! optional flags
+    ! debug mode
+    IF (PRESENT(debug)) THEN
+      mm_debug = debug
+    ELSE
+      mm_debug = .false.
+      call printw("mm_debug",to_string(mm_debug))
+    ENDIF
     ! haze control flags
-    IF (PRESENT(w_haze_prod)) THEN 
+    IF (PRESENT(w_haze_prod)) THEN
       mm_w_haze_prod = w_haze_prod
-    ELSE 
-      mm_w_haze_prod = zwhp 
+    ELSE
+      mm_w_haze_prod = zwhp
       call printw("mm_haze_production",to_string(mm_w_haze_prod))
     ENDIF
-    IF (PRESENT(w_haze_sed)) THEN 
+    IF (PRESENT(w_haze_sed)) THEN
       mm_w_haze_sed = w_haze_sed
-    ELSE 
-      mm_w_haze_sed = zwhs 
+    ELSE
+      mm_w_haze_sed = zwhs
       call printw("mm_haze_sedimentation",to_string(mm_w_haze_sed))
     ENDIF
-    IF (PRESENT(w_haze_coag)) THEN 
+    IF (PRESENT(w_haze_coag)) THEN
       mm_w_haze_coag = w_haze_coag
-    ELSE 
+    ELSE
       mm_w_haze_coag = zwhc
       call printw("mm_haze_coagulation",to_string(mm_w_haze_coag))
     ENDIF
-    IF (PRESENT(force_wsed_to_m0)) THEN 
+    IF (PRESENT(force_wsed_to_m0)) THEN
       mm_wsed_m0 = force_wsed_to_m0
-    ELSE 
+    ELSE
       mm_wsed_m0 = zwstom0
       call printw("mm_wsed_m0",to_string(mm_wsed_m0))
     ENDIF
-    IF (PRESENT(force_wsed_to_m3)) THEN 
+    IF (PRESENT(force_wsed_to_m3)) THEN
       mm_wsed_m3 = force_wsed_to_m3
-    ELSE 
+    ELSE
       mm_wsed_m3 = zwstom3
       call printw("mm_wsed_m3",to_string(mm_wsed_m3))
     ENDIF
-    IF (PRESENT(no_fiadero)) THEN 
+    IF (PRESENT(no_fiadero)) THEN
       mm_no_fiadero_w = no_fiadero
-    ELSE 
-      mm_no_fiadero_w = znofia 
+    ELSE
+      mm_no_fiadero_w = znofia
       call printw("mm_no_fiadero",to_string(mm_no_fiadero_w))
     ENDIF
-    IF (PRESENT(fiadero_min)) THEN 
+    IF (PRESENT(fiadero_min)) THEN
       mm_fiadero_min = fiadero_min
-    ELSE 
+    ELSE
       mm_fiadero_min = zfiamin
       call printw("mm_fiadero_min",to_string(mm_fiadero_min))
     ENDIF
-    IF (PRESENT(fiadero_max)) THEN 
+    IF (PRESENT(fiadero_max)) THEN
       mm_fiadero_max = fiadero_max
-    ELSE 
+    ELSE
       mm_fiadero_max = zfiamax
       call printw("mm_fiadero_max",to_string(mm_fiadero_max))
     ENDIF
+
+    ! moments threshold flags
+    IF (PRESENT(m0as_min)) THEN
+      mm_m0as_min = MAX(0._mm_wp,m0as_min)
+    ELSE
+      call printw("mm_m0as_min",to_string(mm_m0as_min))
+    ENDIF
+    IF (PRESENT(rcs_min)) THEN
+      mm_rcs_min = MAX(1.e-9_mm_wp,rcs_min)
+    ELSE
+      call printw("mm_rcs_min",to_string(mm_rcs_min))
+    ENDIF
+    IF (PRESENT(m0af_min)) THEN
+      mm_m0af_min = MAX(0._mm_wp,m0af_min)
+    ELSE
+      call printw("mm_m0af_min",to_string(mm_m0af_min))
+    ENDIF
+    IF (PRESENT(rcf_min)) THEN
+      mm_rcf_min = MAX(rcf_min,mm_rm)
+    ELSE
+      mm_rcf_min = mm_rm
+      call printw("mm_rcf_min",to_string(mm_rcf_min))
+    ENDIF
+    IF (PRESENT(m0n_min)) THEN
+      mm_m0n_min = MAX(0._mm_wp,m0n_min)
+    ELSE
+      call printw("mm_m0n_min",to_string(mm_m0n_min))
+    ENDIF
+
+    ! compute m3 thresholds from user-defined thresholds.
+    mm_m3as_min  =  mm_m0as_min*mm_alpha_s(3._mm_wp) * mm_rcs_min**3._mm_wp
+    mm_m3af_min  =  mm_m0af_min*mm_alpha_f(3._mm_wp) * mm_rcf_min**3._mm_wp
+    mm_m3cld_min =  mm_m0n_min * (4._mm_wp * mm_pi / 3._mm_wp) * mm_drad_min**3._mm_wp
+
     ! clouds control flags
     IF (mm_w_clouds) THEN
-      IF (PRESENT(w_cloud_sed)) THEN 
+      IF (PRESENT(w_cloud_sed)) THEN
         mm_w_cloud_sed = w_cloud_sed
-      ELSE 
-        mm_w_cloud_sed = zwcs 
-        call printw("mm_cloud_sed",to_string(mm_w_cloud_sed)) 
+      ELSE
+        mm_w_cloud_sed = zwcs
+        call printw("mm_cloud_sed",to_string(mm_w_cloud_sed))
       ENDIF
-      IF (PRESENT(w_cloud_nucond)) THEN 
+      IF (PRESENT(w_cloud_nucond)) THEN
         mm_w_cloud_nucond = w_cloud_nucond
-      ELSE 
+      ELSE
         mm_w_cloud_nucond = zwcs
-        call printw("mm_cloud_nucond",to_string(mm_w_cloud_nucond)) 
+        call printw("mm_cloud_nucond",to_string(mm_w_cloud_nucond))
       ENDIF
     ENDIF
@@ -781,5 +876,5 @@
     mm_ini = err == noerror
 
-    CONTAINS
+  CONTAINS
 
     SUBROUTINE printw(string,value)
@@ -788,6 +883,6 @@
       CHARACTER(len=*), INTENT(in) :: value  !! (string) Value of the option.
       IF (mm_log) &
-      WRITE(*,'(a,a,a)') "warning: Parameter "//string//"not given... Using default value: "//value
-    END SUBROUTINE printw 
+        WRITE(*,'(a,a,a)') "warning: Parameter "//string//"not given... Using default value: "//value
+    END SUBROUTINE printw
   END FUNCTION mm_global_init_0
 
@@ -796,14 +891,15 @@
     !!
     !! See [[mm_globals(module):mm_global_init_0(function)]].
-    TYPE(cfgparser), INTENT(in) :: cfg  !! Configuration file path.
-    TYPE(error) :: err                  !! Error status of the function.
+    TYPE(cfgparser), INTENT(in) :: cfg
+    !! Configuration file path.
+    TYPE(error) :: err
+    !! Error status of the function.
     INTEGER                                           :: i
     TYPE(cfgparser)                                   :: spccfg
     CHARACTER(len=st_slen)                            :: spcpath
-    CHARACTER(len=:), ALLOCATABLE                     :: defmsg
     CHARACTER(len=st_slen), DIMENSION(:), ALLOCATABLE :: species
     REAL(kind=mm_wp)                                  :: zfiamin,zfiamax
     LOGICAL                                           :: zwhp,zwhs,zwhc,zwcs,zwcn,znofia, &
-                                                         zwstom0,zwstom3
+      zwstom0,zwstom3
 
     err = noerror
@@ -856,7 +952,7 @@
       ! Gets species property file path
       err = cfg_get_value(cfg,'specie_cfg',spcpath) ; IF (err /= 0) RETURN
-      ! Reads species properties configuration file  
+      ! Reads species properties configuration file
       err = cfg_read_config(spccfg,trim(spcpath)) ; IF (err /= 0) RETURN
-      err = cfg_get_value(spccfg,"used_species",species) 
+      err = cfg_get_value(spccfg,"used_species",species)
       IF (err /= 0) THEN
         err = error("mm_global_init: cannot retrieve 'used_species' values",-1)
@@ -868,5 +964,5 @@
       !mm_spcname(1:mm_nesp) = species(:)
       DO i=1,mm_nesp
-        mm_spcname(i) = to_lower(species(i))
+        mm_spcname(i) = TRIM(species(i))
         IF (.NOT.cfg_has_section(spccfg,TRIM(mm_spcname(i)))) THEN
           err = error("mm_global_init: Cannot find "//TRIM(mm_spcname(i))//" properties",-1)
@@ -890,4 +986,5 @@
 
     ! MP2M Optional parameters
+    err = mm_check_opt(cfg_get_value(cfg,"debug",mm_debug),mm_debug,.false.,wlog=mm_log)
     err = mm_check_opt(cfg_get_value(cfg,"haze_production",mm_w_haze_prod),mm_w_haze_prod,zwhp,wlog=mm_log)
     err = mm_check_opt(cfg_get_value(cfg,"haze_sedimentation",mm_w_haze_sed),mm_w_haze_sed,zwhs,wlog=mm_log)
@@ -901,4 +998,19 @@
     err = mm_check_opt(cfg_get_value(cfg,"fiadero_max_ratio",mm_fiadero_max),mm_fiadero_max,zfiamax,wlog=mm_log)
 
+    err = mm_check_opt(cfg_get_value(cfg,"m0as_min",mm_m0as_min),mm_m0as_min,1e-10_mm_wp,wlog=mm_log)
+    err = mm_check_opt(cfg_get_value(cfg,"rcs_min",mm_rcs_min),mm_rcs_min,1e-9_mm_wp,wlog=mm_log)
+    err = mm_check_opt(cfg_get_value(cfg,"m0af_min",mm_m0af_min),mm_m0af_min,1e-10_mm_wp,wlog=mm_log)
+    err = mm_check_opt(cfg_get_value(cfg,"rcf_min",mm_rcf_min),mm_rcf_min,mm_rm,wlog=mm_log)
+    err = mm_check_opt(cfg_get_value(cfg,"m0n_min",mm_m0n_min),mm_m0n_min,1e-10_mm_wp,wlog=mm_log)
+
+
+    ! force fractal radius minimum threshold to monomer radius ^^
+    mm_rcf_min = MAX(mm_rm,mm_rcf_min)
+
+    ! compute m3 thresholds from user-defined thresholds.
+    mm_m3as_min  =  mm_m0as_min*mm_alpha_s(3._mm_wp) * mm_rcs_min**3._mm_wp
+    mm_m3af_min  =  mm_m0af_min*mm_alpha_f(3._mm_wp) * mm_rcf_min**3._mm_wp
+    mm_m3cld_min =  mm_m0n_min * (4._mm_wp * mm_pi / 3._mm_wp) * mm_drad_min**3._mm_wp
+
     err = noerror
     ! special check for settling velocity
@@ -911,8 +1023,8 @@
   FUNCTION mm_column_init(plev,zlev,play,zlay,temp) RESULT(err)
     !! Initialize vertical atmospheric fields.
-    !! 
+    !!
     !! This subroutine initializes vertical fields needed by the microphysics:
     !!
-    !! 1. Save reversed input field into "local" array 
+    !! 1. Save reversed input field into "local" array
     !! 2. Compute thicknesses layers and levels
     !! 3. Interpolate temperature at levels
@@ -922,5 +1034,5 @@
     !! @attention
     !! All the input vectors should be defined from __GROUND__ to __TOP__ of the atmosphere,
-    !! otherwise nasty things will occur in computations. 
+    !! otherwise nasty things will occur in computations.
     REAL(kind=mm_wp), DIMENSION(:), INTENT(in) :: plev !! Pressure levels (Pa).
     REAL(kind=mm_wp), DIMENSION(:), INTENT(in) :: zlev !! Altitude levels (m).
@@ -930,5 +1042,5 @@
     TYPE(error) :: err                                 !! Error status of the function.
     INTEGER :: i
-    mm_ini_col = .false.                          
+    mm_ini_col = .false.
     err = noerror
     IF (.NOT.mm_ini) THEN
@@ -980,6 +1092,6 @@
     ! Hydrostatic equilibrium
     mm_rhoair(1:mm_nla) = (mm_plev(2:mm_nle)-mm_plev(1:mm_nla)) / &
-                          (mm_effg(mm_zlay)*mm_dzlev)
-    mm_ini_col = .true.                          
+      (mm_effg(mm_zlay)*mm_dzlev)
+    mm_ini_col = .true.
     ! write out profiles (only if BOTH debug and log are enabled).
     IF (mm_log.AND.mm_debug) THEN
@@ -1003,15 +1115,15 @@
   FUNCTION mm_aerosols_init(m0aer_s,m3aer_s,m0aer_f,m3aer_f) RESULT(err)
     !! Initialize clouds tracers vertical grid.
-    !! 
-    !! The subroutine initializes aerosols microphysics tracers columns. It allocates variables if 
-    !! required and stores input vectors in reversed order. It also computes the characteristic radii 
-    !! of each mode. 
+    !!
+    !! The subroutine initializes aerosols microphysics tracers columns. It allocates variables if
+    !! required and stores input vectors in reversed order. It also computes the characteristic radii
+    !! of each mode.
     !! @note
-    !! All the input arguments should be defined from ground to top. 
+    !! All the input arguments should be defined from ground to top.
     !!
     !! @attention
     !! [[mm_globals(module):mm_global_init(interface)]] and [[mm_globals(module):mm_column_init(function)]]
     !! must have been called at least once before this method is called. Moreover, this method should be
-    !! after each call of [[mm_globals(module):mm_column_init(function)]] to reflect changes in the 
+    !! after each call of [[mm_globals(module):mm_column_init(function)]] to reflect changes in the
     !! vertical atmospheric structure.
     REAL(kind=mm_wp), DIMENSION(:), INTENT(in) :: m0aer_s !! \(0^{th}\) order moment of the spherical mode (\(m^{-2}\)).
@@ -1063,14 +1175,9 @@
     mm_m0aer_f = m0aer_f(mm_nla:1:-1)/mm_dzlev(:)
     mm_m3aer_f = m3aer_f(mm_nla:1:-1)/mm_dzlev(:)
+
+    ! Setup threshold:
+    call mm_set_moments_thresholds()
+
     ! aerosols characteristic radii
-    ! il faudrait peut etre revoir la gestion des zeros ici et la 
-    ! remplacer par une valeur seuil des moments.
-    !
-    !-> JVO 19 : Done. Zero threshold set at espilon from dynamics on the
-    ! input moments in calmufi (safer than here). Might still be some unphysical
-    ! values after the dynamics near the threshold. Could be a could idea to add
-    ! a sanity check filtering too high values of radii.
-    !
-    ! TBD : Add a sanity check for high radii ????
     WHERE(mm_m3aer_s > 0._mm_wp .AND. mm_m0aer_s > 0._mm_wp)
       mm_rcs = mm_get_rcs(mm_m0aer_s,mm_m3aer_s)
@@ -1088,15 +1195,15 @@
   FUNCTION mm_clouds_init(m0ccn,m3ccn,m3ice,gazs) RESULT(err)
     !! Initialize clouds tracers vertical grid.
-    !! 
-    !! The subroutine initializes cloud microphysics tracers columns. It allocates variables if 
-    !! required and stores input vectors in reversed order. It also computes the mean drop radius 
+    !!
+    !! The subroutine initializes cloud microphysics tracers columns. It allocates variables if
+    !! required and stores input vectors in reversed order. It also computes the mean drop radius
     !! and density and allocates diagnostic vectors.
     !! @note
-    !! All the input arguments should be defined from ground to top. 
+    !! All the input arguments should be defined from ground to top.
     !!
     !! @attention
     !! [[mm_globals(module):mm_global_init(interface)]] and [[mm_globals(module):mm_column_init(function)]]
     !! must have been called at least once before this method is called. Moreover, this method should be
-    !! after each call of [[mm_globals(module):mm_column_init(function)]] to reflect changes in the 
+    !! after each call of [[mm_globals(module):mm_column_init(function)]] to reflect changes in the
     !! vertical atmospheric structure.
     REAL(kind=mm_wp), DIMENSION(:), INTENT(in)   :: m0ccn !! 0th order moment of the CCN distribution (\(m^{-2}\)).
@@ -1121,5 +1228,5 @@
     !  Actually, mm_nla should always initialized the first time mm_column_init is called, NOT HERE.
     IF (mm_nla < 0)  mm_nla  = SIZE(gazs,DIM=1)
-    ! Note: 
+    ! Note:
     !   here we could check that mm_nesp is the same size of gazs(DIM=2)
     !   Actually, mm_nesp should be always initialized in mm_global_init, NOT HERE.
@@ -1134,4 +1241,7 @@
     IF (.NOT.ALLOCATED(mm_drho))    ALLOCATE(mm_drho(mm_nla))
     ! Allocate memory for diagnostics
+    IF (.NOT.ALLOCATED(mm_ccn_w)) THEN
+      ALLOCATE(mm_ccn_w(mm_nla)) ; mm_ccn_w(:) = 0._mm_wp
+    ENDIF
     IF (.NOT.ALLOCATED(mm_ccn_flux)) THEN
       ALLOCATE(mm_ccn_flux(mm_nla)) ; mm_ccn_flux(:) = 0._mm_wp
@@ -1154,4 +1264,8 @@
       mm_gazs(:,i)  = gazs(mm_nla:1:-1,i)
     ENDDO
+
+    ! Setup threshold :
+    call mm_set_moments_cld_thresholds()
+
     ! drop mean radius
     call mm_cloud_properties(mm_m0ccn,mm_m3ccn,mm_m3ice,mm_drad,mm_drho)
@@ -1162,4 +1276,6 @@
     !! Dump model global parameters on stdout.
     WRITE(*,'(a)')         "========= YAMMS PARAMETERS ============"
+    WRITE(*,'(a,a)')       "mm_fp_precision        : ", mm_wp_s
+    WRITE(*,'(a,L2)')      "mm_debug               : ", mm_debug
     WRITE(*,'(a,L2)')      "mm_w_haze_prod         : ", mm_w_haze_prod
     WRITE(*,'(a,ES14.7)')  "   mm_p_prod           : ", mm_p_prod
@@ -1168,5 +1284,5 @@
     WRITE(*,'(a,L2)')      "mm_w_haze_coag         : ", mm_w_haze_coag
     WRITE(*,'(a,I2.2)')    "   mm_coag_interactions: ", mm_coag_choice
-    WRITE(*,'(a,L2)')      "mm_w_haze_sed          : ", mm_w_haze_sed 
+    WRITE(*,'(a,L2)')      "mm_w_haze_sed          : ", mm_w_haze_sed
     WRITE(*,'(a,L2)')      "   mm_wsed_m0          : ", mm_wsed_m0
     WRITE(*,'(a,L2)')      "   mm_wsed_m3          : ", mm_wsed_m3
@@ -1178,4 +1294,15 @@
     WRITE(*,'(a,L2)')      "   mm_w_cloud_nucond   : ", mm_w_cloud_nucond
     WRITE(*,'(a)')         "---------------------------------------"
+    WRITE(*,'(a)')         "Thresholds spherical mode"
+    WRITE(*,'(a,ES14.7)')  "  mm_m0as_min          : ", mm_m0as_min
+    WRITE(*,'(a,ES14.7)')  "  mm_rcs_min           : ", mm_rcs_min
+    WRITE(*,'(a)')         "Thresholds fractal mode"
+    WRITE(*,'(a,ES14.7)')  "  mm_m0af_min          : ", mm_m0af_min
+    WRITE(*,'(a,ES14.7)')  "  mm_rcf_min           : ", mm_rcf_min
+    WRITE(*,'(a)')         "Thresholds clouds drop"
+    WRITE(*,'(a,ES14.7)')  "  mm_m0n_min           : ", mm_m0n_min
+    WRITE(*,'(a,ES14.7)')  "  mm_drad_min          : ", mm_drad_min
+    WRITE(*,'(a,ES14.7)')  "  mm_drad_max          : ", mm_drad_max
+    WRITE(*,'(a)')         "---------------------------------------"
     WRITE(*,'(a,ES14.7)')  "mm_dt                  : ", mm_dt
     IF (mm_nla > -1) THEN
@@ -1191,15 +1318,70 @@
   END SUBROUTINE mm_dump_parameters
 
+  SUBROUTINE mm_set_moments_thresholds()
+    !! Apply minimum threshold for the aerosols moments.
+    !!
+    !! The method resets moments (for both modes and orders, 0 and 3) values to zero if
+    !! their current value is below the minimum threholds.
+    !!
+    !! See also [[mm_globals(module):mm_m0as_min(variable)]], [[mm_globals(module):mm_rcs_min(variable)]],
+    !! [[mm_globals(module):mm_rcf_min(variable)]] and [[mm_globals(module):mm_m0as_min(variable)]].
+    INTEGER :: i
+    DO i=1,mm_nla
+      IF ((mm_m0aer_s(i) < mm_m0as_min) .OR. (mm_m3aer_s(i) < mm_m3as_min)) THEN
+        mm_m0aer_s(i) = 0._mm_wp ! mm_m0as_min
+        mm_m3aer_s(i) = 0._mm_wp ! mm_m0as_min * mm_rcs_min**3._mm_wp * mm_alpha_s(3._mm_wp)
+      ENDIF
+      IF ((mm_m0aer_f(i) < mm_m0af_min) .OR. (mm_m3aer_f(i) < mm_m3af_min)) THEN
+        mm_m0aer_f(i) = 0._mm_wp ! mm_m0af_min
+        mm_m3aer_f(i) = 0._mm_wp ! mm_m0af_min * mm_rcf_min**3._mm_wp * mm_alpha_f(3._mm_wp)
+      ENDIF
+    ENDDO
+  END SUBROUTINE mm_set_moments_thresholds
+
+  SUBROUTINE mm_set_moments_cld_thresholds()
+    !! Apply minimum threshold for the cloud drop moments.
+    !!
+    !! The method resets moments (for both modes and orders, 0 and 3) values to zero if
+    !! their current value is below the minimum threholds.
+    INTEGER :: i, j
+    REAL(kind=mm_wp) :: m3cld
+
+    DO i = 1, mm_nla
+      m3cld = mm_m3ccn(i)
+      DO j = 1, mm_nesp
+        m3cld = m3cld + mm_m3ice(i,j)
+      ENDDO
+
+      IF ((mm_m0ccn(i) < mm_m0n_min) .OR. (m3cld < mm_m3cld_min)) THEN
+        mm_m0ccn(i) = 0._mm_wp
+        mm_m3ccn(i) = 0._mm_wp
+        DO j = 1, mm_nesp
+          mm_m3ice(i,j) = 0._mm_wp
+        ENDDO
+      ENDIF
+    ENDDO
+  END SUBROUTINE mm_set_moments_cld_thresholds
+
+  ELEMENTAL SUBROUTINE mm_check_tendencies(v,dv)
+    !! Check that tendencies is not greater than value.
+    !!
+    !! the purpose of the subroutine is to update dvalue so that v+dv is not negative.
+    REAL(kind=mm_wp), INTENT(in)    :: v  !! Value to check.
+    REAL(kind=mm_wp), INTENT(inout) :: dv !! Value tendencies to check and update consequently.
+    REAL(kind=mm_wp), PARAMETER :: a = (epsilon(1._mm_wp)-1._mm_wp)
+    IF (v+dv < 0._mm_wp) THEN
+      dv = a*v
+    ENDIF
+  END SUBROUTINE mm_check_tendencies
+
   ELEMENTAL FUNCTION mm_get_rcs(m0,m3) RESULT(res)
     !! Get the characteristic radius for the spherical aerosols size distribution.
-    !! 
+    !!
     !! The method computes the characteristic radius of the size distribution law
     !! of the spherical aerosols mode according to its moments and its inter-moments
     !! relation.
-    REAL(kind=mm_wp), INTENT(in) :: m0 !! \(0^{th}\) order moment 
+    REAL(kind=mm_wp), INTENT(in) :: m0 !! \(0^{th}\) order moment
     REAL(kind=mm_wp), INTENT(in) :: m3 !! \(3^{rd}\) order moment
     REAL(kind=mm_wp) :: res            !! Radius
-    ! arbitrary: if there is no way to compute radius 
-    IF (m3 <= 0._mm_wp .OR. m0 <= 0._mm_wp) res = 1._mm_wp 
     res = (m3/m0/mm_alpha_s(3._mm_wp))**(1._mm_wp/3._mm_wp)
   END FUNCTION mm_get_rcs
@@ -1207,17 +1389,15 @@
   ELEMENTAL FUNCTION mm_get_rcf(m0,m3) RESULT(res)
     !! Get the characteristic radius for the fractal aerosols size distribution.
-    !! 
+    !!
     !! The method computes the characteristic radius of the size distribution law
     !! of the fractal aerosols mode according to its moments and its inter-moments
     !! relation.
-    REAL(kind=mm_wp), INTENT(in) :: m0 !! \(0^{th}\) order moment 
+    REAL(kind=mm_wp), INTENT(in) :: m0 !! \(0^{th}\) order moment
     REAL(kind=mm_wp), INTENT(in) :: m3 !! \(3^{rd}\) order moment
     REAL(kind=mm_wp) :: res            !! Radius
-    ! arbitrary: if there is no way to compute radius 
-    IF (m3 <= 0._mm_wp .OR. m0 <= 0._mm_wp) res = 1._mm_wp 
     res = (m3/m0/mm_alpha_f(3._mm_wp))**(1._mm_wp/3._mm_wp)
   END FUNCTION mm_get_rcf
 
-  ELEMENTAL FUNCTION mm_effg(z) RESULT(effg) 
+  ELEMENTAL FUNCTION mm_effg(z) RESULT(effg)
     !! Compute effective gravitational acceleration.
     REAL(kind=mm_wp), INTENT(in) :: z !! Altitude in meters
@@ -1226,5 +1406,5 @@
     IF (mm_use_effg) effg = effg * (mm_rpla/(mm_rpla+z))**2
     RETURN
-  END FUNCTION mm_effg 
+  END FUNCTION mm_effg
 
   !==================================
@@ -1237,39 +1417,43 @@
     !! The method computes the mean radius and mean density of cloud drops.
     !!
-    !! @bug 
-    !! A possible bug can happen because of threshold snippet. If __drad__ is greater than 
-    !! __drmax__ (== 100 microns) it is automatically set to __drmax__, but computation of 
+    !! @bug
+    !! A possible bug can happen because of threshold snippet. If __drad__ is greater than
+    !! __drmax__ (== 1e3 microns) it is automatically set to __drmax__, but computation of
     !! __drho__ remains unmodified. So __drho__ is not correct in that case.
     !!
-    !! @todo 
-    !! Fix the bug of the subroutine, but it is rather minor, since theoretically we do not 
+    !! @todo
+    !! Fix the bug of the subroutine, but it is rather minor, since theoretically we do not
     !! need the density of the drop.
     !!
-    !! @todo 
-    !! Think about a better implementation of thresholds, and get sure of their consequences in 
-    !! the other parts of the model. 
-    REAL(kind=mm_wp), INTENT(in)               :: m0ccn !! \(0^{th}\) order moment of the ccn 
-    REAL(kind=mm_wp), INTENT(in)               :: m3ccn !! \(3^{rd}\) order moment of the ccn 
+    !! @todo
+    !! Think about a better implementation of thresholds, and get sure of their consequences in
+    !! the other parts of the model.
+    REAL(kind=mm_wp), INTENT(in)               :: m0ccn !! \(0^{th}\) order moment of the ccn
+    REAL(kind=mm_wp), INTENT(in)               :: m3ccn !! \(3^{rd}\) order moment of the ccn
     REAL(kind=mm_wp), INTENT(in), DIMENSION(:) :: m3ice !! \(3^{rd}\) order moments of each ice component
-    REAL(kind=mm_wp), INTENT(out)              :: drad  !! Output mean drop radius 
+    REAL(kind=mm_wp), INTENT(out)              :: drad  !! Output mean drop radius
     REAL(kind=mm_wp), INTENT(out), OPTIONAL    :: drho  !! Optional output mean drop density
-    REAL(kind=mm_wp)            :: vtot, wtot, ntot 
-    REAL(kind=mm_wp), PARAMETER :: threshold = 1.e-25_mm_wp,         &  
-                                       drmin = 1.e-10_mm_wp,         &
-                                       drmax = 1.e-4_mm_wp,          &
-                                      athird = 1._mm_wp/3._mm_wp,    &
-                                       pifac = 4._mm_wp/3._mm_wp*mm_pi 
+    REAL(kind=mm_wp)            :: Ntot, Vtot, Wtot
+    REAL(kind=mm_wp), PARAMETER :: athird = 1._mm_wp / 3._mm_wp
+    REAL(kind=mm_wp), PARAMETER :: pifac  = (4._mm_wp * mm_pi) / 3._mm_wp
+    
+    ! Set to zero :
     drad = 0._mm_wp
-    ntot = m0ccn
-    vtot = pifac*m3ccn+SUM(m3ice)
-    wtot = pifac*m3ccn*mm_rhoaer+SUM(m3ice*mm_xESPS(:)%rho)
-    IF (ntot <= threshold .OR. vtot <= 0._mm_wp) THEN
-      drad  = drmin
-      IF (PRESENT(drho)) drho  = mm_rhoaer 
-    ELSE
-      drad = (vtot/ntot/pifac)**athird
-      drad = MAX(MIN(drad,drmax),drmin)
-      IF (PRESENT(drho)) drho = wtot/vtot
-    ENDIF
+    IF (PRESENT(drho)) drho  = 0._mm_wp
+    
+    ! Initialization :
+    Ntot = m0ccn
+    Vtot = pifac * m3ccn + SUM(m3ice)
+    Wtot = pifac * ((m3ccn*mm_rhoaer) + SUM(m3ice*mm_xESPS(:)%rho))
+
+    IF (Ntot <= mm_m0n_min .OR. Vtot <= mm_m3cld_min) THEN
+      drad = mm_drad_min
+      IF (PRESENT(drho)) drho = mm_rhoaer
+    ELSE
+      drad = (Vtot / (pifac*Ntot))**athird
+      drad = MAX(MIN(drad,mm_drad_max),mm_drad_min)
+      IF (PRESENT(drho)) drho = Wtot / Vtot
+    ENDIF
+
     RETURN
   END SUBROUTINE cldprop_sc
@@ -1286,33 +1470,14 @@
     REAL(kind=mm_wp), INTENT(out), DIMENSION(:)           :: drad  !! Output mean drop radius.
     REAL(kind=mm_wp), INTENT(out), DIMENSION(:), OPTIONAL :: drho  !! Optional output mean drop density.
-    INTEGER                                     :: i,ns
-    REAL(kind=mm_wp), DIMENSION(:), ALLOCATABLE :: vtot,wtot,ntot,rho 
-    REAL(kind=mm_wp), PARAMETER                 :: threshold = 1.e-25_mm_wp,         &  
-                                                       drmin = 1.e-10_mm_wp,         &
-                                                       drmax = 1.e-4_mm_wp,          &
-                                                      athird = 1._mm_wp/3._mm_wp,    &
-                                                       pifac = 4._mm_wp/3._mm_wp*mm_pi
-                                                     
-    ns = SIZE(m0ccn) ; ALLOCATE(vtot(ns),wtot(ns),ntot(ns),rho(ns))
-    drad = 0._mm_wp
-    ntot = m0ccn
-    vtot = pifac*m3ccn+SUM(m3ice,DIM=2)
-    wtot = pifac*m3ccn*mm_rhoaer
-    DO i=1,SIZE(m3ice,DIM=2)
-      wtot = wtot+m3ice(:,i)*mm_xESPS(i)%rho
-    ENDDO
-    WHERE(ntot <= threshold .OR. vtot <= 0._mm_wp) 
-      drad  = drmin
-      rho = mm_rhoaer
-    ELSEWHERE 
-      drad = (vtot/ntot/pifac)**athird
-      drad = MAX(MIN(drad,drmax),drmin)
-      rho = wtot/vtot
-    END WHERE
-    IF (PRESENT(drho)) drho  = rho
+    INTEGER :: i
+    IF (PRESENT(drho)) THEN
+      DO i = 1, SIZE(m0ccn) ; call cldprop_sc(m0ccn(i),m3ccn(i),m3ice(i,:),drad(i),drho(i)) ; ENDDO
+    ELSE
+      DO i = 1, SIZE(m0ccn) ; call cldprop_sc(m0ccn(i),m3ccn(i),m3ice(i,:),drad(i)) ; ENDDO
+    ENDIF
     RETURN
   END SUBROUTINE cldprop_ve
 
-  ! For configuration file (requires fccp library).
+  ! For configuration file (requires swift library).
 
   FUNCTION read_esp(parser,sec,pp) RESULT (err)
@@ -1322,23 +1487,23 @@
     TYPE(mm_esp), INTENT(out)     :: pp     !! [[mm_globals(module):mm_esp(type)]] object that stores the parameters.
     TYPE(error)                   :: err    !! Error status of the function.
-    err = cfg_get_value(parser,TRIM(sec)//'name',pp%name)       ; IF (err /= 0) RETURN
-    err = cfg_get_value(parser,TRIM(sec)//'mas',pp%mas)         ; IF (err /= 0) RETURN
-    err = cfg_get_value(parser,TRIM(sec)//'vol',pp%vol)         ; IF (err /= 0) RETURN
-    err = cfg_get_value(parser,TRIM(sec)//'ray',pp%ray)         ; IF (err /= 0) RETURN
-    err = cfg_get_value(parser,TRIM(sec)//'mas',pp%mas)         ; IF (err /= 0) RETURN
-    err = cfg_get_value(parser,TRIM(sec)//'vol',pp%vol)         ; IF (err /= 0) RETURN
-    err = cfg_get_value(parser,TRIM(sec)//'ray',pp%ray)         ; IF (err /= 0) RETURN
-    err = cfg_get_value(parser,TRIM(sec)//'masmol',pp%masmol)   ; IF (err /= 0) RETURN
-    err = cfg_get_value(parser,TRIM(sec)//'rho',pp%rho)         ; IF (err /= 0) RETURN
-    err = cfg_get_value(parser,TRIM(sec)//'tc',pp%tc)           ; IF (err /= 0) RETURN
-    err = cfg_get_value(parser,TRIM(sec)//'pc',pp%pc)           ; IF (err /= 0) RETURN
-    err = cfg_get_value(parser,TRIM(sec)//'tb',pp%tb)           ; IF (err /= 0) RETURN
-    err = cfg_get_value(parser,TRIM(sec)//'w',pp%w)             ; IF (err /= 0) RETURN
-    err = cfg_get_value(parser,TRIM(sec)//'a_sat',pp%a_sat)     ; IF (err /= 0) RETURN
-    err = cfg_get_value(parser,TRIM(sec)//'b_sat',pp%b_sat)     ; IF (err /= 0) RETURN
-    err = cfg_get_value(parser,TRIM(sec)//'c_sat',pp%c_sat)     ; IF (err /= 0) RETURN
-    err = cfg_get_value(parser,TRIM(sec)//'d_sat',pp%d_sat)     ; IF (err /= 0) RETURN
-    err = cfg_get_value(parser,TRIM(sec)//'mteta',pp%mteta)     ; IF (err /= 0) RETURN
-    err = cfg_get_value(parser,TRIM(sec)//'tx_prod',pp%tx_prod) ; IF (err /= 0) RETURN
+    err = cfg_get_value(parser,TRIM(sec)//'/name',pp%name)       ; IF (err /= 0) RETURN
+    err = cfg_get_value(parser,TRIM(sec)//'/mas',pp%mas)         ; IF (err /= 0) RETURN
+    err = cfg_get_value(parser,TRIM(sec)//'/vol',pp%vol)         ; IF (err /= 0) RETURN
+    err = cfg_get_value(parser,TRIM(sec)//'/ray',pp%ray)         ; IF (err /= 0) RETURN
+    err = cfg_get_value(parser,TRIM(sec)//'/mas',pp%mas)         ; IF (err /= 0) RETURN
+    err = cfg_get_value(parser,TRIM(sec)//'/vol',pp%vol)         ; IF (err /= 0) RETURN
+    err = cfg_get_value(parser,TRIM(sec)//'/ray',pp%ray)         ; IF (err /= 0) RETURN
+    err = cfg_get_value(parser,TRIM(sec)//'/masmol',pp%masmol)   ; IF (err /= 0) RETURN
+    err = cfg_get_value(parser,TRIM(sec)//'/rho',pp%rho)         ; IF (err /= 0) RETURN
+    err = cfg_get_value(parser,TRIM(sec)//'/tc',pp%tc)           ; IF (err /= 0) RETURN
+    err = cfg_get_value(parser,TRIM(sec)//'/pc',pp%pc)           ; IF (err /= 0) RETURN
+    err = cfg_get_value(parser,TRIM(sec)//'/tb',pp%tb)           ; IF (err /= 0) RETURN
+    err = cfg_get_value(parser,TRIM(sec)//'/w',pp%w)             ; IF (err /= 0) RETURN
+    err = cfg_get_value(parser,TRIM(sec)//'/a_sat',pp%a_sat)     ; IF (err /= 0) RETURN
+    err = cfg_get_value(parser,TRIM(sec)//'/b_sat',pp%b_sat)     ; IF (err /= 0) RETURN
+    err = cfg_get_value(parser,TRIM(sec)//'/c_sat',pp%c_sat)     ; IF (err /= 0) RETURN
+    err = cfg_get_value(parser,TRIM(sec)//'/d_sat',pp%d_sat)     ; IF (err /= 0) RETURN
+    err = cfg_get_value(parser,TRIM(sec)//'/mteta',pp%mteta)     ; IF (err /= 0) RETURN
+    err = cfg_get_value(parser,TRIM(sec)//'/tx_prod',pp%tx_prod) ; IF (err /= 0) RETURN
     RETURN
   END FUNCTION read_esp
@@ -1346,5 +1511,5 @@
   ! =========================================================================
   ! %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
-  !                CONFIGURATION PARSER checking methods 
+  !                CONFIGURATION PARSER checking methods
   ! %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
   ! =========================================================================
@@ -1352,6 +1517,6 @@
   FUNCTION check_r1(err,var,def,wlog) RESULT(ret)
     !! Check an option value (float).
-    !! 
-    !! The method checks an option value and optionally set a default value, __def__ to initialize 
+    !!
+    !! The method checks an option value and optionally set a default value, __def__ to initialize
     !! __var__ on error if given.
     TYPE(error), INTENT(in)                :: err  !! Error object from value getter.
@@ -1360,5 +1525,5 @@
     LOGICAL, INTENT(in), OPTIONAL          :: wlog !! .true. to print warning/error message.
     TYPE(error) :: ret                             !! Input error.
-    CHARACTER(len=*), PARAMETER :: defmsg = '... Using default value: ' 
+    CHARACTER(len=*), PARAMETER :: defmsg = '... Using default value: '
     LOGICAL                     :: zlog
     ret = err
@@ -1376,6 +1541,6 @@
   FUNCTION check_l1(err,var,def,wlog) RESULT(ret)
     !! Check an option value (logical).
-    !! 
-    !! The method checks an option value and optionally set a default value, __def__ to initialize 
+    !!
+    !! The method checks an option value and optionally set a default value, __def__ to initialize
     !! __var__ on error if given.
     TYPE(error), INTENT(in)       :: err  !! Error object from value getter.
